tp_obj tp_print(tp_obj params) {
    TP_PBEGIN(params);
    int n = 0;
    tp_obj e;
    TP_PLOOP(e)
        if (n) { printf(" "); }
        printf("%s",tp_cstring(tp_str(vm,e)));
        n += 1;
    TP_PEOL;
    TP_PEND;
    printf("\n");
    return None;
}

tp_obj tp_bind(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj r = TP_POBJ("fnc");
    tp_obj self = TP_POBJ("self");
    TP_PEND;
    r.fnc.self = tp_ptr(self);
    if (r.type == TP_DEF) { r.def.globals = tp_ptr(*(tp_obj*)r.def.globals); }
    tp_track(vm,r);
    return r;
}

tp_obj tp_min(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj r = TP_PNEXT();
    tp_obj e;
    TP_PLOOP(e)
        if (tp_cmp(vm,r,e).number.val > 0) { r = e; }
    TP_PEOL;
    TP_PEND;
    return r;
}

tp_obj tp_max(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj r = TP_PNEXT();
    tp_obj e;
    TP_PLOOP(e)
        if (tp_cmp(vm,r,e).number.val < 0) { r = e; }
    TP_PEOL;
    TP_PEND;
    return r;
}

tp_obj tp_copy(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj r = TP_POBJ("val");
    TP_PEND;
    int type = r.type;
    if (type == TP_LIST) {
        return _tp_list_copy(vm,r);
    } else if (type == TP_DICT) {
        return _tp_dict_copy(vm,r);
    } else if (type == TP_PARAMS) {
    }
    tp_raise(None,"tp_copy(%s)",STR(r));
}


tp_obj tp_len_(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj e = TP_POBJ("val");
    TP_PEND;
    return tp_len(vm,e);
}


tp_obj tp_assert(tp_obj params) {
    TP_PBEGIN(params);
    int a = TP_PNUMBER("val");
    TP_PEND;
    if (a) { return None; }
    tp_raise(None,"%s","assert failed");
}

tp_obj tp_range(tp_obj params) {
    TP_PBEGIN(params);
//     fprintf(stderr,"begin range params\n");
    int a = TP_PNUMBER("a");
    int b = TP_PNUMBER("b");
    int c = TP_PDEFAULT("c",tp_number(1)).number.val;
//     fprintf(stderr,"end range params\n");
    TP_PEND;
    tp_obj r = tp_list(vm,0,0);
    int i;
    for (i=a; i<b; i+=c) {
        _tp_list_append(vm,r.list.val,tp_number(i));
    }
//     fprintf(stderr,"done range\n");
    return r;
}


tp_obj tp_system(tp_obj params) {
    TP_PBEGIN(params);
    char *s = TP_PSTRING("val");
    TP_PEND;
    int r = system(s);
    return tp_number(r);
}

tp_obj tp_istype(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj v = TP_POBJ("val");
    char *t = TP_PSTRING("type");
    TP_PEND;
    if (strcmp("string",t) == 0) { return tp_number(v.type == TP_STRING); }
    if (strcmp("list",t) == 0) { return tp_number(v.type == TP_LIST); }
    if (strcmp("dict",t) == 0) { return tp_number(v.type == TP_DICT); }
    if (strcmp("number",t) == 0) { return tp_number(v.type == TP_NUMBER); }
    tp_raise(None,"is_type(%s,%s)",STR(v),t);
}


tp_obj tp_float(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj v = TP_POBJ("val");
    int ord = TP_PDEFAULT("ord",tp_number(0)).number.val;
    TP_PEND;
    int type = v.type;
    if (type == TP_NUMBER) {
        return v;
    } else if (type == TP_STRING) {
        if (strchr(tp_cstring(v),'.')) { return tp_number(atof(tp_cstring(v))); }
        return tp_number(strtol(tp_cstring(v),0,ord));
    }
    tp_raise(None,"tp_float(%s)",STR(v));
}


tp_obj tp_save(tp_obj params) {
    TP_PBEGIN(params);
    char *fname = TP_PSTRING("fname");
    tp_obj v = TP_POBJ("val");
    TP_PEND;
    FILE *f;
    f = fopen(fname,"wb");
    if (!f) { tp_raise(None,"tp_save(%s,...)",fname); }
    fwrite(v.string.val,v.string.len,1,f);
    fclose(f);
    return None;
}

tp_obj tp_load(tp_obj params) {
    TP_PBEGIN(params);
    char *fname = TP_PSTRING("fname");
    TP_PEND;
    FILE *f;
    f = fopen(fname,"rb");
    if (!f) { tp_raise(None,"tp_load(%s)",fname); }
    long l = tp_FileSize(fname);
    char *s = tp_malloc(l+1); s[l]=0;
    fread(s,1,l,f);
    fclose(f);
    return tp_string_t(vm,s,l);
}


tp_obj tp_fpack(tp_obj params) {
    TP_PBEGIN(params);
    float v = TP_PNUMBER("val");
    TP_PEND;
    float *r = tp_malloc(sizeof(v)); *r = v;
    return tp_string_t(vm,(char*)r,sizeof(v));
}

tp_obj tp_abs(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj e = TP_POBJ("val");
    TP_PEND;
    return tp_number(fabs(e.number.val));
}
tp_obj tp_int(tp_obj params) {
    return tp_number((int)tp_float(params).number.val);
}
tp_obj tp_round(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj e = TP_POBJ("val");
    TP_PEND;
    return tp_number(roundf(e.number.val));
}

tp_obj tp_exists(tp_obj params) {
    TP_PBEGIN(params);
    char *s = TP_PSTRING("fname");
    TP_PEND;
    struct stat stbuf;
    return tp_number(!stat(s,&stbuf));
}
tp_obj tp_mtime(tp_obj params) {
    TP_PBEGIN(params);
    char *s = TP_PSTRING("fname");
    TP_PEND;
    struct stat stbuf;
    if (!stat(s,&stbuf)) { return tp_number(stbuf.st_mtime); }
    tp_raise(None,"tp_mtime(%s)",s);
}
