void _tp_list_realloc(_tp_list *self,int len) {
    if (!len) { len=1; }
    self->items = tp_realloc(self->items,len*sizeof(tp_obj));
    self->alloc = len;
}

void _tp_list_set(TP,_tp_list *self,int k, tp_obj v, char *error) {
    if (k >= self->len) { tp_raise(,"%s: KeyError: %d\n",error,k); }
    self->items[k] = v;
    tp_grey(vm,v);
}
void _tp_list_free(_tp_list *self) {
    tp_free(self->items);
    tp_free(self);
}

tp_obj _tp_list_get(TP,_tp_list *self,int k,char *error) {
    if (k >= self->len) { tp_raise(None,"%s: KeyError: %d\n",error,k); }
    return self->items[k];
}
void _tp_list_insertx(TP,_tp_list *self, int n, tp_obj v) {
    if (self->len >= self->alloc) {
        _tp_list_realloc(self,self->alloc*2);
    }
    memmove(&self->items[n+1],&self->items[n],sizeof(tp_obj)*(self->len-n));
    self->items[n] = v;
    self->len += 1;
}
void _tp_list_appendx(TP,_tp_list *self, tp_obj v) {
    _tp_list_insertx(vm,self,self->len,v);
}
void _tp_list_insert(TP,_tp_list *self, int n, tp_obj v) {
    _tp_list_insertx(vm,self,n,v);
    tp_grey(vm,v);
}
void _tp_list_append(TP,_tp_list *self, tp_obj v) {
    _tp_list_insert(vm,self,self->len,v);
}
tp_obj _tp_list_pop(TP,_tp_list *self, int n, char *error) {
    tp_obj r = _tp_list_get(vm,self,n,error);
    memmove(&self->items[n],&self->items[n+1],sizeof(tp_obj)*(self->len-(n+1)));
    self->len -= 1;
    return r;
}

int _tp_list_find(TP,_tp_list *self, tp_obj v) {
    int n;
    for (n=0; n<self->len; n++) {
        if (tp_cmp(vm,v,self->items[n]).number.val==0) {
            return n;
        }
    }
    return -1;
}

tp_obj tp_index(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj self = TP_POBJ("self");
    tp_obj v = TP_POBJ("val");
    TP_PEND;
    int i = _tp_list_find(vm,self.list.val,v);
    if (i < 0) { tp_raise(None,"tp_index(%s,%s) - item not found",STR(self),STR(v)); }
    return tp_number(i);
}

_tp_list *_tp_list_new(int len) {
    _tp_list *self = tp_malloc(sizeof(_tp_list));
    self->items = 0;
    self->len = 0;
    self->alloc = 0;
    _tp_list_realloc(self,len);
    return self;
}

tp_obj _tp_list_copy(TP, tp_obj rr) {
    _tp_list *o = rr.list.val;
    _tp_list *r = _tp_list_new(o->alloc);
    memcpy(r->items,o->items,sizeof(tp_obj)*o->alloc);
    r->len = o->len;
    
    rr.type = TP_LIST;
    rr.list.val = r;
    tp_track(vm,rr);
//     tp_follow(vm,rr);
    return rr;
}

tp_obj tp_append(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj self = TP_POBJ("self");
    tp_obj v = TP_POBJ("val");
    TP_PEND;
    _tp_list_append(vm,self.list.val,v);
    return None;
}

tp_obj tp_pop(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj self = TP_POBJ("self");
    TP_PEND;
    return _tp_list_pop(vm,self.list.val,self.list.val->len-1,"pop");
}

tp_obj tp_insert(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj self = TP_POBJ("self");
    int n = TP_PNUMBER("index");
    tp_obj v = TP_POBJ("val");
    TP_PEND;
    _tp_list_insert(vm,self.list.val,n,v);
    return None;
}

tp_obj tp_extend(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj self = TP_POBJ("self");
    tp_obj v = TP_POBJ("val");
    TP_PEND;
    int i;
    for (i=0; i<v.list.val->len; i++) {
        _tp_list_append(vm,self.list.val,v.list.val->items[i]);
    }
    return None;
}

tp_obj tp_list(TP,int len,tp_obj argv[]) {
    int i;
    tp_obj r;
    r.type = TP_LIST;
    r.list.val = _tp_list_new(len);
    for (i=0; i<len; i++) {
        _tp_list_append(vm,r.list.val,argv[i]);
    }
//     r.list.hash = lua_hash(&r.list.val,sizeof(void*));
    tp_track(vm,r);
    return r;
}

tp_obj tp_list_new(int len) {
    tp_obj r;
    r.type = TP_LIST;
    r.list.val = _tp_list_new(len);
    return r;
}

int _tp_sort_cmp(tp_obj *a,tp_obj *b) {
    return tp_cmp(0,*a,*b).number.val;
}
tp_obj tp_sort(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj self = TP_POBJ("self");
    TP_PEND;
    qsort(self.list.val->items, self.list.val->len, sizeof(tp_obj), (int(*)(const void*,const void*))_tp_sort_cmp);
    return None;
}



//


