def shrink(fname):
    f = open(fname,'r'); lines = f.readlines(); f.close()
    out = []
    fixes = [
    'vm','gc','params',
    'int','float','return',
    'abs','round','system','pow','div','raise','hash','index','printf']
    for line in lines:
        #change "    " into "\t" and remove blank lines
        if len(line.strip()) == 0: continue
        line = line.rstrip()
        l1,l2 = len(line),len(line.lstrip())
        line = "\t"*((l1-l2)/4)+line.lstrip()
        
        #remove comments
        if '.c' in fname or '.h' in fname:
            if line.strip()[:2] == '//': continue
        if '.py' in fname:
            if line.strip()[:1] == '#': continue
            
        #remove the "namespace penalty" from tinypy ...
        for name in fixes:
            line = line.replace('tp_'+name,'t'+name)
        line = line.replace('TP_','')
        line = line.replace('tp_','')
        
        out.append(line)
    return '\n'.join(out)+'\n'

if __name__ == '__main__':
    for fname in [
        'pylang.py','dumbparse.py','dump2vm.py','py2c.py',
        'tp.h','tp.c','dict.c','list.c','vm.c',
        'string.c','builtins.c','util.c','tgc.c',
        'boot.py','vmsdl.c','vmmain.c','tinypy.c',
        ]:
        txt = shrink(fname)
        f = open(fname,'w')
        f.write(txt)
        f.close()
