tp_obj tp_string_n(char *v,int n) {
    tp_obj r;
    r.type = TP_STRING;
    r.string.val = v;
    r.string.len = n;
    return r;
}
tp_obj tp_string_t(TP, char *v, int n) {
    tp_obj r = tp_string_n(v,n);
    return tp_track_s(vm,r);
}
tp_obj tp_string(char *v) { return tp_string_n(v,strlen(v)); }

int _tp_str_index(tp_obj s, tp_obj k) {
    int i=0;
    while ((s.string.len - i) >= k.string.len) {
        if (memcmp(s.string.val+i,k.string.val,k.string.len) == 0) {
            return i;
        }
        i += 1;
    }
    return -1;
}

tp_obj tp_join(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj delim = TP_POBJ("delim");
    tp_obj val = TP_POBJ("val");
    TP_PEND;
    int l=0,i;
    for (i=0; i<val.list.val->len; i++) {
        if (i!=0) { l += delim.string.len; }
        l += tp_str(vm,val.list.val->items[i]).string.len;
    }
    char *s = tp_malloc(l+1); s[l]=0;
    l = 0;
    for (i=0; i<val.list.val->len; i++) {
        if (i!=0) {
            memcpy(s+l,delim.string.val,delim.string.len); l += delim.string.len;
        }
        tp_obj e = tp_str(vm,val.list.val->items[i]);
        memcpy(s+l,e.string.val,e.string.len); l += e.string.len;
    }
    return tp_string_t(vm,s,l);
}

tp_obj tp_string_slice(TP,tp_obj s, int a, int b) {
    char *m = tp_malloc(b-a+1); m[b-a] = 0;
    memcpy(m,s.string.val+a,b-a);
    return tp_string_t(vm,m,b-a);
}

tp_obj tp_split(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj v = TP_POBJ("val");
    tp_obj d = TP_POBJ("delim");
    TP_PEND;
    tp_obj r = tp_list(vm,0,0);
    
    int i;
    while ((i=_tp_str_index(v,d))!=-1) {
        _tp_list_append(vm,r.list.val,tp_string_slice(vm,v,0,i));
        v.string.val += i + d.string.len; v.string.len -= i + d.string.len;
//         tp_grey(vm,r); // should stop gc or something instead
    }
    _tp_list_append(vm,r.list.val,tp_string_slice(vm,v,0,v.string.len));
//     tp_grey(vm,r); // should stop gc or something instead
    return r;
}


tp_obj _tp_number2char(TP,float v) {
    if ((fabs(v)-abs((int)v)) < 0.000001) { return tp_printf(vm,"%d",(int)v); }
    return tp_printf(vm,"%f",v);
}


tp_obj tp_find(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj s = TP_POBJ("self");
    tp_obj v = TP_POBJ("val");
    TP_PEND;
    return tp_number(_tp_str_index(s,v));
}

tp_obj tp_str_index(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj s = TP_POBJ("self");
    tp_obj v = TP_POBJ("val");
    TP_PEND;
    int n = _tp_str_index(s,v);
    if (n >= 0) { return tp_number(n); }
    tp_raise(None,"tp_str_index(%s,%s)",s,v);
}

tp_obj tp_str2(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj v = TP_POBJ("val");
    TP_PEND;
    return tp_str(vm,v);
}

tp_obj tp_chr(tp_obj params) {
    TP_PBEGIN(params);
    int v = TP_PNUMBER("val");
    TP_PEND;
    return tp_printf(vm,"%c",v);
}
tp_obj tp_ord(tp_obj params) {
    TP_PBEGIN(params);
    char *s = TP_PSTRING("val");
    TP_PEND;
    return tp_number(s[0]);
}

char *tp_cstring(tp_obj v) {
    if (v.type == TP_STRING) {
        if (v.string.val[v.string.len] == 0) {
            return v.string.val;
        }
    }
    char *s = tp_malloc(v.string.len+1);
    memcpy(s,v.string.val,v.string.len);
    s[v.string.len] = 0;
    printf("warning: tp_cstring(%s)\n",s);
    return s;
}

tp_obj tp_strip(tp_obj params) {
    TP_PBEGIN(params);
    char *v = TP_PSTRING("val");
    TP_PEND;
    int i, l = strlen(v); int a = l, b = 0;
    for (i=0; i<l; i++) {
        if (v[i] != ' ' && v[i] != '\n' && v[i] != '\t' && v[i] != '\r') {
            a = _tp_min(a,i); b = _tp_max(b,i+1);
        }
    }
    if ((b-a) < 0) { return tp_string(""); }
    char *s = tp_malloc(b-a+1); s[b-a] = 0; memcpy(s,v+a,b-a);
    return tp_string_t(vm,s,b-a);
}


tp_obj tp_replace(tp_obj params) {
    TP_PBEGIN(params);
    tp_obj s = TP_POBJ("self");
    tp_obj k = TP_POBJ("old");
    tp_obj v = TP_POBJ("new");
    TP_PEND;
    tp_obj p = s;
    int i,n = 0;
    while ((i = _tp_str_index(p,k)) != -1) {
        n += 1;
        p.string.val += i + k.string.len; p.string.len -= i + k.string.len;
    }
//     fprintf(stderr,"ns: %d\n",n);
    int l = s.string.len + n * (v.string.len-k.string.len);
    int c;
    char *r = tp_malloc(l+1); r[l] = 0;
    char *d = r;
    tp_obj z; z = p = s;
    while ((i = _tp_str_index(p,k)) != -1) {
        p.string.val += i; p.string.len -= i;
        memcpy(d,z.string.val,c=(p.string.val-z.string.val)); d += c;
        p.string.val += k.string.len; p.string.len -= k.string.len;
        memcpy(d,v.string.val,v.string.len); d += v.string.len;
        z = p;
    }
    memcpy(d,z.string.val,(s.string.val + s.string.len) - z.string.val); 
    
    return tp_string_t(vm,r,l);
}

