#include "SDL.h"
#include "tp.h"

/*#define TP_FNC(...) \
    vm->file = tp_string(__FILE__)
    vm->lineno = tp_string(__LINE__)
    vm->name = "##NAME##"*/

// TP_FNC(set_mode) {
//     int w = P_NUMBER("w");
//     int h = P_NUMBER("h");
//     P_END;


SDL_Surface *s;
tp_obj set_mode(tp_obj params) {
    TP_PBEGIN(params);
    int w = TP_PNUMBER("w");
    int h = TP_PNUMBER("h");
    TP_PEND;
    SDL_Init(SDL_INIT_EVERYTHING);
    s = SDL_SetVideoMode(w,h,32,0);
    return None;
}

void real_set_pixel(int x, int y, int c) {
    if (x<s->clip_rect.x || y <s->clip_rect.y || x >= (s->clip_rect.x+s->clip_rect.w) || y >=(s->clip_rect.y+s->clip_rect.h)) { return ; }  
    Uint32 *p = (Uint32*)((Uint8*)s->pixels+y*s->pitch);
    *(p+x) = (Uint32)c;
}

tp_obj set_pixel(tp_obj params) {
    TP_PBEGIN(params);
    int x = TP_PNUMBER("x");
    int y = TP_PNUMBER("y");
    int c = TP_PNUMBER("c");
    TP_PEND;
    real_set_pixel(x,y,c);
    return None;
}


tp_obj update(tp_obj params) {
    TP_PBEGIN(params);
    int x = TP_PNUMBER("x");
    int y = TP_PNUMBER("y");
    int w = TP_PNUMBER("w");
    int h = TP_PNUMBER("h");
    TP_PEND;
    SDL_Rect r;
    r.x=x;r.y=y;r.w=w;r.h=h;
    SDL_UpdateRects(s, 1, &r);
    return None;
}

tp_obj get_ticks(tp_obj params) {
    TP_PBEGIN(params);TP_PEND;
    tp_obj r;
    r.type = TP_NUMBER;
    r.number.val = SDL_GetTicks();
    return r;
}

tp_obj _sdl_event_get(TP,tp_obj self, tp_obj k) {
    SDL_Event *e = self.data.val;
    char *key = STR(k);
    if (strcmp(key,"type")==0) { return tp_number(e->type); }
    return None;
}
// void *_sdl_event_meta[] = {_sdl_event_get};
tp_meta _sdl_event_meta = {_sdl_event_get,0,0};
tp_obj gfx_get_event(tp_obj params) {
    TP_PBEGIN(params);TP_PEND;
    tp_obj r;
    SDL_Event *e = malloc(sizeof(SDL_Event));
    if (SDL_PollEvent(e)) {
        r.type = TP_DATA;
        r.data.val = e;
        r.data.meta = &_sdl_event_meta;
        return r;
    }
    return None;
}

tp_obj get_mouse_pos(tp_obj params) {
    TP_PBEGIN(params);TP_PEND;
    int x,y,b;
    b = SDL_GetMouseState(&x,&y);
    tp_obj r;
    r = tp_dict(vm,6,(tp_obj[]){
        tp_string("x"),tp_number(x),
        tp_string("y"),tp_number(y),
        tp_string("b"),tp_number(b)
        });
    return r;
}


void sdl_init(TP) {
    tp_obj context = vm->builtins;
    tp_set(vm,context,tp_string("set_mode"),tp_fnc(set_mode));
    tp_set(vm,context,tp_string("set_pixel"),tp_fnc(set_pixel));
    tp_set(vm,context,tp_string("update"),tp_fnc(update));
    tp_set(vm,context,tp_string("get_ticks"),tp_fnc(get_ticks));
    tp_set(vm,context,tp_string("gfx_get_event"),tp_fnc(gfx_get_event));
    tp_set(vm,context,tp_string("get_mouse_pos"),tp_fnc(get_mouse_pos));
}
//

